
_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68

;ADC_test.c,29 :: 		void main() {
;ADC_test.c,32 :: 		unsigned val = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
;ADC_test.c,33 :: 		unsigned long clk=0;
;ADC_test.c,36 :: 		trisd1_bit = 0;
	BCLR	TRISD1_bit, BitPos(TRISD1_bit+0)
;ADC_test.c,37 :: 		latd1_bit = 0;
	BCLR	LATD1_bit, BitPos(LATD1_bit+0)
;ADC_test.c,39 :: 		InitTimer1();
	CALL	_InitTimer1
;ADC_test.c,41 :: 		pwm_init();
	CALL	_pwm_init
;ADC_test.c,43 :: 		ADC_init();
	CALL	_ADC_init
;ADC_test.c,45 :: 		LCD_init();
	CALL	_Lcd_Init
;ADC_test.c,47 :: 		lcd_cmd(_lcd_cursor_off);
	MOV.B	#12, W10
	CALL	_Lcd_Cmd
;ADC_test.c,48 :: 		lcd_cmd(_lcd_clear);
	MOV.B	#1, W10
	CALL	_Lcd_Cmd
;ADC_test.c,51 :: 		ADIF_bit = 0;
	BCLR	ADIF_bit, BitPos(ADIF_bit+0)
;ADC_test.c,53 :: 		INTCON1bits.NSTDIS = 1;   // interrupt nesting disabled
	BSET	INTCON1bits, #15
;ADC_test.c,54 :: 		PTCONbits.PTEN = 1;       // pwm enabled
	BSET	PTCONbits, #15
;ADC_test.c,55 :: 		ADON_bit = 1;             // adc enabled
	BSET	ADON_bit, BitPos(ADON_bit+0)
;ADC_test.c,56 :: 		ADCON1bits.ASAM = 1;      // auto sampling enabled
	BSET	ADCON1bits, #2
;ADC_test.c,57 :: 		ADIE_bit = 1;             // adc interrupt enabled
	BSET	ADIE_bit, BitPos(ADIE_bit+0)
;ADC_test.c,61 :: 		longwordtostr(clk, txt1);
	MOV	#lo_addr(_txt1), W12
	MOV	#128, W10
	MOV	#0, W11
	CALL	_LongWordToStr
;ADC_test.c,62 :: 		lcd_out(2, 1, txt1);
	MOV	#lo_addr(_txt1), W12
	MOV	#1, W11
	MOV	#2, W10
	CALL	_Lcd_Out
;ADC_test.c,63 :: 		delay_ms(1000);
	MOV	#163, W8
	MOV	#49887, W7
L_main0:
	DEC	W7
	BRA NZ	L_main0
	DEC	W8
	BRA NZ	L_main0
	NOP
	NOP
;ADC_test.c,64 :: 		lcd_cmd(_lcd_clear);
	MOV.B	#1, W10
	CALL	_Lcd_Cmd
;ADC_test.c,69 :: 		while(1)
L_main2:
;ADC_test.c,73 :: 		if(ticks_lcd == 1000)
	MOV	_ticks_lcd, W1
	MOV	#1000, W0
	CP	W1, W0
	BRA Z	L__main6
	GOTO	L_main4
L__main6:
;ADC_test.c,75 :: 		val = adc_value;
; val start address is: 0 (W0)
	MOV	_adc_value, W0
;ADC_test.c,76 :: 		wordtostr(val, adc_txt);
	MOV	#lo_addr(_adc_txt), W11
	MOV	W0, W10
; val end address is: 0 (W0)
	CALL	_WordToStr
;ADC_test.c,77 :: 		lcd_out(2, 4, adc_txt);
	MOV	#lo_addr(_adc_txt), W12
	MOV	#4, W11
	MOV	#2, W10
	CALL	_Lcd_Out
;ADC_test.c,78 :: 		ticks_lcd = 0;
	CLR	W0
	MOV	W0, _ticks_lcd
;ADC_test.c,79 :: 		}
L_main4:
;ADC_test.c,81 :: 		}
	GOTO	L_main2
;ADC_test.c,85 :: 		}
L_end_main:
	POP	W12
	POP	W11
	POP	W10
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main

_ADC_init:

;ADC_test.c,88 :: 		void ADC_init(void)
;ADC_test.c,91 :: 		ADCON1 = 0x0060;       // continue idle mode, integer format, motor control trigger, sequential sampling, SAMP auto = 0
	MOV	#96, W0
	MOV	WREG, ADCON1
;ADC_test.c,92 :: 		ADCHS = 0x0000;        // ch0 positve input AN0, ch0 negative -VREF, CH1 positive AN0, CH1 negative -VREF
	CLR	ADCHS
;ADC_test.c,93 :: 		ADCSSL = 0;            // no scan
	CLR	ADCSSL
;ADC_test.c,94 :: 		ADCON3 = 0x0009;       // auto sample time = 0Tad, system clock, ADCS<5:0> = 9
	MOV	#9, W0
	MOV	WREG, ADCON3
;ADC_test.c,95 :: 		ADCON2 = 0x0104;       // converts CH0 and CH1, 2 conversions per interrupt
	MOV	#260, W0
	MOV	WREG, ADCON2
;ADC_test.c,96 :: 		IPC0 = IPC0 | 0x7000;  // priority 7
	MOV	#28672, W1
	MOV	#lo_addr(IPC0), W0
	IOR	W1, [W0], [W0]
;ADC_test.c,97 :: 		ADPCFG = 0xFFFE;       // AN0 is analog
	MOV	#65534, W0
	MOV	WREG, ADPCFG
;ADC_test.c,99 :: 		}
L_end_ADC_init:
	RETURN
; end of _ADC_init

_pwm_init:

;ADC_test.c,101 :: 		void pwm_init(void)
;ADC_test.c,103 :: 		PTCON.PTEN = 0;           // pwm timebase off
	BCLR	PTCON, #15
;ADC_test.c,104 :: 		PWMCON1.PEN1L = 1;        // PWM1L pin is configured for pwm operation
	BSET	PWMCON1, #0
;ADC_test.c,105 :: 		PWMCON1bits.PMOD1 = 1;    // PWM1L and PWM1H pair is independent
	BSET	PWMCON1bits, #8
;ADC_test.c,106 :: 		PTCONbits.PTMOD = 2;       // free running mode
	MOV.B	#2, W0
	MOV.B	W0, W1
	MOV	#lo_addr(PTCONbits), W0
	XOR.B	W1, [W0], W1
	AND.B	W1, #3, W1
	MOV	#lo_addr(PTCONbits), W0
	XOR.B	W1, [W0], W1
	MOV	#lo_addr(PTCONbits), W0
	MOV.B	W1, [W0]
;ADC_test.c,107 :: 		PTCONbits.PTOPS = 0;       // 1:1
	MOV	#lo_addr(PTCONbits), W0
	MOV.B	[W0], W1
	MOV.B	#15, W0
	AND.B	W1, W0, W1
	MOV	#lo_addr(PTCONbits), W0
	MOV.B	W1, [W0]
;ADC_test.c,108 :: 		PTCONbits.PTCKPS = 0;      // 1:1  pwm timebase input clock is Tcy
	MOV	#lo_addr(PTCONbits), W0
	MOV.B	[W0], W1
	MOV.B	#243, W0
	AND.B	W1, W0, W1
	MOV	#lo_addr(PTCONbits), W0
	MOV.B	W1, [W0]
;ADC_test.c,109 :: 		PTCONbits.PTSIDL = 0;      // pwm runs in idle mode
	BCLR	PTCONbits, #13
;ADC_test.c,110 :: 		SEVTCMP =  159;            // Triggers the ADC in the middle of PWM off time
	MOV	#159, W0
	MOV	WREG, SEVTCMP
;ADC_test.c,111 :: 		PTPER = 159;               // period register value. 100kHz for up-down mode
	MOV	#159, W0
	MOV	WREG, PTPER
;ADC_test.c,112 :: 		PDC1 = 160;                // duty cycle 0.5
	MOV	#160, W0
	MOV	WREG, PDC1
;ADC_test.c,114 :: 		}
L_end_pwm_init:
	RETURN
; end of _pwm_init

_InitTimer1:

;ADC_test.c,120 :: 		void InitTimer1(){
;ADC_test.c,121 :: 		T1CON = 0x8000;
	MOV	#32768, W0
	MOV	WREG, T1CON
;ADC_test.c,122 :: 		TMR1 = 0;
	CLR	TMR1
;ADC_test.c,123 :: 		T1IE_bit = 1;
	BSET	T1IE_bit, BitPos(T1IE_bit+0)
;ADC_test.c,124 :: 		T1IF_bit = 0;
	BCLR	T1IF_bit, BitPos(T1IF_bit+0)
;ADC_test.c,125 :: 		IPC0 = IPC0 | 0x6000;     // priority 6
	MOV	#24576, W1
	MOV	#lo_addr(IPC0), W0
	IOR	W1, [W0], [W0]
;ADC_test.c,127 :: 		PR1 = 32000;              // 1ms
	MOV	#32000, W0
	MOV	WREG, PR1
;ADC_test.c,128 :: 		}
L_end_InitTimer1:
	RETURN
; end of _InitTimer1

_ADCInt:
	PUSH	52
	PUSH	RCOUNT
	PUSH	W0
	MOV	#2, W0
	REPEAT	#12
	PUSH	[W0++]

;ADC_test.c,131 :: 		void ADCInt() iv IVT_ADDR_ADCINTERRUPT ics ICS_AUTO
;ADC_test.c,134 :: 		adc_value = ADCBUF0;
	MOV	ADCBUF0, WREG
	MOV	W0, _adc_value
;ADC_test.c,135 :: 		latd1_bit = !latd1_bit;
	BTG	LATD1_bit, BitPos(LATD1_bit+0)
;ADC_test.c,136 :: 		ADIF_bit = 0;
	BCLR	ADIF_bit, BitPos(ADIF_bit+0)
;ADC_test.c,138 :: 		}
L_end_ADCInt:
	MOV	#26, W0
	REPEAT	#12
	POP	[W0--]
	POP	W0
	POP	RCOUNT
	POP	52
	RETFIE
; end of _ADCInt

_T1Int:
	PUSH	52
	PUSH	RCOUNT
	PUSH	W0
	MOV	#2, W0
	REPEAT	#12
	PUSH	[W0++]

;ADC_test.c,140 :: 		void T1Int() iv IVT_ADDR_T1INTERRUPT ics ICS_AUTO
;ADC_test.c,142 :: 		ticks_lcd++;
	MOV	_ticks_lcd, W0
	INC	W0
	MOV	W0, _ticks_lcd
;ADC_test.c,143 :: 		T1IF_bit = 0;
	BCLR	T1IF_bit, BitPos(T1IF_bit+0)
;ADC_test.c,144 :: 		}
L_end_T1Int:
	MOV	#26, W0
	REPEAT	#12
	POP	[W0--]
	POP	W0
	POP	RCOUNT
	POP	52
	RETFIE
; end of _T1Int
